#include<iostream>
using namespace std;

//1|2|3
//-----
//4|5|6
//-----
//7|8|9

void displayGameBoard(char gameBoard[])
{
	system("cls");
	cout << gameBoard[0] << '|';
	cout << gameBoard[1] << '|';
	cout << gameBoard[2] << endl;
	cout << "-----" << endl;
	cout << gameBoard[3] << '|';
	cout << gameBoard[4] << '|';
	cout << gameBoard[5] << endl;
	cout << "-----" << endl;
	cout << gameBoard[6] << '|';
	cout << gameBoard[7] << '|';
	cout << gameBoard[8] << endl << endl;

}

void applyMoveToGameBoard(char gameBoard[], char turn)
{
	int move;
	do
	{
		cout << turn << "'s Move? ";
		cin >> move;
		move--;
	} while (move < 0 || move > 8 || 
		gameBoard[move] == 'X' || gameBoard[move] == 'O');

	gameBoard[move] = turn;
}

bool boardHasWinner(char gameBoard[], char player)
{
	bool result = false;

	if (gameBoard[0] == player && gameBoard[1] == player && gameBoard[2] == player)
	{
		result = true;
	}
	if (gameBoard[3] == player && gameBoard[4] == player && gameBoard[5] == player)
	{
		result = true;
	}
	if (gameBoard[6] == player && gameBoard[7] == player && gameBoard[8] == player)
	{
		result = true;
	}
	if (gameBoard[0] == player && gameBoard[3] == player && gameBoard[6] == player)
	{
		result = true;
	}
	if (gameBoard[1] == player && gameBoard[4] == player && gameBoard[7] == player)
	{
		result = true;
	}
	if (gameBoard[2] == player && gameBoard[5] == player && gameBoard[8] == player)
	{
		result = true;
	}
	if (gameBoard[0] == player && gameBoard[4] == player && gameBoard[8] == player)
	{
		result = true;
	}
	if (gameBoard[2] == player && gameBoard[4] == player && gameBoard[6] == player)
	{
		result = true;
	}


	return result;
}

void main()
{
	char gameBoard[9] = { '1', '2', '3', '4', '5', '6', '7', '8', '9'};
	displayGameBoard(gameBoard);
	char turn = 'X';
	bool gameOver = false;
	int movesMade = 0;

	while (!gameOver && movesMade < 9)
	{
		movesMade++;
		applyMoveToGameBoard(gameBoard, turn);
		displayGameBoard(gameBoard);
		if (turn == 'X')
		{
			turn = 'O';
		}
		else
		{
			turn = 'X';
		}

		if (boardHasWinner(gameBoard, 'X'))
		{
			cout << "X wins" << endl;
			gameOver = true;
		}
		if (boardHasWinner(gameBoard, 'O'))
		{
			cout << "O wins" << endl;
			gameOver = true;
		}
	}
}